package com.github.jfcloud.util;

import freemarker.template.Configuration;
import freemarker.template.Template;
import freemarker.template.TemplateException;
import sun.misc.BASE64Encoder;

import javax.servlet.http.HttpServletResponse;
import java.io.*;
import java.util.Iterator;
import java.util.Map;

public class WordUtil {


    /**
     * @param mouldName 模板的名称 比如"basic.ftl"
     * @param dataMap   传入的数据（key=ftl 中的站位的名称同时 要是String ）
     * @param fileName  最后生成的word文件的名称
     * @param response
     * @throws IOException
     */
    public static void exportWord(String mouldName, Map<String, Object> dataMap, String fileName, HttpServletResponse response) throws IOException {
        Configuration configuration = new Configuration();
        configuration.setDefaultEncoding("utf-8");
        if (dataMap != null) {
            Iterator it = dataMap.entrySet().iterator();
            while (it.hasNext()) {
                Map.Entry entry = (Map.Entry) it.next();
                String key = (String) entry.getKey();
                Object value = entry.getValue();
                dataMap.put(key, value == null ? "" : value);//集合
            }
        }
        // 所在的项目中的路径
        configuration.setClassForTemplateLoading(WordUtil.class, "/fileTemp");
        Template t = null;
        try {
            //test.ftl word模板文件
            t = configuration.getTemplate(mouldName);
        } catch (IOException e) {
            e.printStackTrace();
        }
        response.setContentType("application/x-msdownload");
        response.setHeader("Content-Disposition", "attachment;filename=" + fileName);
        response.setHeader("Content-Disposition", "attachment;filename=" + new String(fileName.getBytes("gbk"), "iso-8859-1"));

        Writer out = null;
        try {
            try {
                out = new BufferedWriter(new OutputStreamWriter(response.getOutputStream(), "UTF-8"));
            } catch (UnsupportedEncodingException e) {
                // TODO Auto-generated catch block
                e.printStackTrace();
            }
        } catch (FileNotFoundException e1) {
            e1.printStackTrace();
        }
        try {
            t.process(dataMap, out);
        } catch (TemplateException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }


    }


    /**
     * @param mouldName 模板的名称 比如"basic.ftl"
     * @param dataMap   传入的数据（key=ftl 中的站位的名称同时 要是String ）
     * @throws IOException
     */
    public static InputStream exportWord(String mouldName, Map<String, Object> dataMap) throws IOException {
        Configuration configuration = new Configuration();
        configuration.setDefaultEncoding("utf-8");
        if (dataMap != null) {
            Iterator it = dataMap.entrySet().iterator();
            while (it.hasNext()) {
                Map.Entry entry = (Map.Entry) it.next();
                String key = (String) entry.getKey();
                Object value = entry.getValue();
                dataMap.put(key, value == null ? "" : value);//集合
            }
        }
        // 所在的项目中的路径
        configuration.setClassForTemplateLoading(WordUtil.class, "/fileTemplate");
        Template t = null;
        try {
            //test.ftl word模板文件
            t = configuration.getTemplate(mouldName);
        } catch (IOException e) {
            e.printStackTrace();
        }
        Writer out = null;
        ByteArrayOutputStream outputStream = new ByteArrayOutputStream();
        try {
            //out = new BufferedWriter(new OutputStreamWriter(response.getOutputStream(), "UTF-8"));
            out = new BufferedWriter(new OutputStreamWriter(outputStream, "UTF-8"));
        } catch (UnsupportedEncodingException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        try {
            t.process(dataMap, out);
            InputStream inputStream = new ByteArrayInputStream(outputStream.toByteArray());
            return inputStream;
        } catch (TemplateException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }
        return null;
    }

    /**
     * 图片转换
     * @param inputStream
     * @return
     */
    public static String getImgFileToBase64(InputStream inputStream) {
        //将图片文件转化为字节数组字符串，并对其进行Base64编码处理
        byte[] buffer = null;
        //读取图片字节数组
        try {
            int count = 0;
            while (count == 0) {
                count = inputStream.available();
            }
            buffer = new byte[count];
            inputStream.read(buffer);
        } catch (IOException e) {
            e.printStackTrace();
        } finally {
            if (inputStream != null) {
                try {
                    // 关闭inputStream流
                    inputStream.close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        }
        // 对字节数组Base64编码
        return new BASE64Encoder().encode(buffer);
    }
}

